#include <cassert>
#include "xf/timeout.h"
#include "xf/initialevent.h"
#include "xf/behavior.h"

// TODO done: Implement code for XFBehavior class

XFBehavior::XFBehavior() {

}

XFBehavior::~XFBehavior() {

}

void XFBehavior::startBehavior() {
    GEN(XFInitialEvent());
}

void XFBehavior::pushEvent(XFEvent *pEvent) {
    pEvent->setBehavior(this);
    this->getDispatcher()->pushEvent(pEvent);
}

bool XFBehavior::deleteOnTerminate() const {
    return deleteOnTerminate_;
}

void XFBehavior::setDeleteOnTerminate(bool deleteBehaviour) {
    deleteOnTerminate_ = deleteBehaviour;
}

const XFEvent *XFBehavior::getCurrentEvent() const {
    return pCurrentEvent_;
}

interface::XFDispatcher *XFBehavior::getDispatcher() {
    return interface::XFDispatcher::getInstance();
}

const XFTimeout *XFBehavior::getCurrentTimeout() {
    if(pCurrentEvent_->getEventType() == XFEvent::Timeout) {
        return (XFTimeout*) pCurrentEvent_;
    } else {
        return nullptr;
    }
}

void XFBehavior::setCurrentEvent(const XFEvent *pEvent) {
    pCurrentEvent_ = pEvent;
}

XFBehavior::TerminateBehavior XFBehavior::process(const XFEvent *pEvent) {
    setCurrentEvent(pEvent);
    XFEventStatus status = XFEventStatus::Unknown;
    status = processEvent();
    if(status == XFEventStatus::Consumed) {
        return deleteOnTerminate_;
    } else {
        return false;
    }
}
